//"ekspPN.sci","Eksport PN - include","\Eksport\Eksport include\",0,2.0.0,SYSTEM
/////////////////////////////////////////
// "Eksport PN - include"
// ekspPN.sci
/////////////////////////////////////////

int DECLARE PrintError(String msg)

int Sub EksportPN(long idPN)
	Dispatch xRapPn=xFactory.NewObject("BRapPn")
	dispatch xGetParams = xFactory.NewObject("XParams")
	dispatch xRejestr
	Dispatch xTypDokumentuPn
	Dispatch xDokPn = xFactory.NewObject("BDokPn")
	Dispatch xDokumentPn = xFactory.NewObject("BDokumentPn")
	Dispatch xKartParamsDokPn = xFactory.NewObject("BKartParamsDokPn")
	Dispatch xRj = xFactory.GetObject("BRj")
	rozUidStrona = 0
	int err, nRes, ii
	EksportPN = 1

	xRapPn = xRapPnMan.Give(using "id=%d",idPN)

//	if xRapPn.IsNull() then PrintError( "Brak takiego rekordu w bazie PN")

	eksport.PoczatekSekcji("Dokument", idPN)

		xGetParams.id = xRapPn.rejestr.id
		xRejestr = xFactory.GetObject("BRejestr", xGetParams)

		xTypDokumentuPn = GetObjById("BTypDokumentuPn", xRapPn.typDokumentu.id)
		if !xTypDokumentuPn then PrintError("Brak BTypDokumentuPn")
		eksport.Pole("symbol FK", xTypDokumentuPn.symbolFK)
		eksport.Pole("obsluguj jak", xTypDokumentuPn.TypFK)

		eksport.Pole("kod", xRapPn.numer)
		eksport.Pole("opis FK", (Using "rejestr %s za dzie %s", xRejestr.kod, xRapPn.data))
		eksport.Pole("dataWystawienia", xRapPn.data)
		eksport.Pole("dataSprzedazy", xRapPn.data)
		eksport.Pole("kwota", (Using "%.2f", xRapPn.wplaty + xRapPn.wyplaty))
		eksport.Pole("Sygnatura", xFactory.uzytkownik.kod)
		eksport.Pole("SaldoPRK", (Using "%.2f", xRapPn.otwarcie))
		eksport.Pole("SaldoZRK", (Using "%.2f", xRapPn.wplaty - xRapPn.wyplaty))
		eksport.Pole("KontoKasy", xRejestr.kontoFK)

		//////////////////////////////////////////////////////
		// numer dokumentu w FK
		eksport.Pole("FK nazwa", xRapPn.numer)

		// dokumenty patnoci dla danego raportu
		for ii=1 to ii>xRj.Count()
			if xRj.item(ii).id==xRejestr.id then exit
		next ii

		xKartParamsDokPn.terminPlatnosci = xRapPn.data
		if ii<=xRj.Count() then xKartParamsDokPn.rejestr = xRj.item(ii)
		xKartParamsDokPn.waluta = xRapPn.waluta

		nRes = xDokPn.Load(xKartParamsDokPn)

		ii=1
		while !nRes && ii <= xDokPn.Count()


			nRes = xDokumentPn.Load("id="+(using "%l",xDokPn.item(ii).id))
			if nRes then  PrintError("Brak takiego rekordu w bazie PN")

			if xDokumentPn.Wyplata == 0 || xDokumentPn.Wyplata == 1 then
				if 0 != xDokumentPn.danekh.KhID then
					select case xDokumentPn.danekh.KhTyp
						case 2 // pracownik
							EksportWR(xDokumentPn.danekh.KhID, 0)
						case 3 // urzad
							EksportUZ(xDokumentPn.danekh.KhID, 0)
						case 1 // kontrahent
							EksportKH(xDokumentPn.danekh.KhID, 0)
					endselect
				endif
			endif
			ii=ii+1
		wend

		xDekretacjeRapPn.Clear()
		xDekretParamsPn = xDekretacjeRapPn.Params()
		xDekretParamsPn.id=xRapPn.id
		xDekretacjeRapPn.Dekret(xDekretParamsPn)

		ZapiszZAP(xDekretacjeRapPn, 0, IIF(xTypDokumentuPn.TypFK == "WB", 2, 3), "", 0, 0)
		ZapiszTRAROZ(xDekretacjeRapPn, 1, 0)
		ZapiszBANKOPER(xDekretacjeRapPn)

	eksport.KoniecSekcji() //"Dokument"
EndSub



//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
// zbiorcze

record ZapisRejRec
	long idRejestr
	string strNazwa[41]
	string strDataOd[11]
	string strDataDo[11]
	float dKwota
	float dSaldoPRK
	float dSaldoZRK
	string strObslJak[7]
	string strSymbolFK[41]
	string strKonto[41]
	string strKod[41]

	Dispatch m_DekretParamsPn //=xFactory.NewObject("BDekretParams")
	Dispatch m_DekretacjeRapPn //=xFactory.NewObject("BDekretacjeRapPn")
endrec

ZapisRejRec ZapisRejTab(1)

int Sub EksportPN_zb_begin()
EndSub

int Sub EksportPN_zb_do(long idPN)
	Dispatch xRapPn=xFactory.NewObject("BRapPn")
	dispatch xGetParams = xFactory.NewObject("XParams")
	dispatch xRejestr
	Dispatch xTypDokumentuPn
	Dispatch xDokPn = xFactory.NewObject("BDokPn")
	Dispatch xDokumentPn = xFactory.NewObject("BDokumentPn")
	Dispatch xKartParamsDokPn = xFactory.NewObject("BKartParamsDokPn")
	Dispatch xRj = xFactory.GetObject("BRj")

	int err, nRes, ii

	EksportPN_zb_do = 1

	int index


	xRapPn = xRapPnMan.Give(using "id=%d",idPN)
	if !xRapPn then PrintError("Brak takiego rekordu w bazie PN")

	xGetParams.id = xRapPn.rejestr.id
	xRejestr = xFactory.GetObject("BRejestr", xGetParams)
	if !xRejestr then PrintError("Brak takiego rekordu")

	index = 1
	while index < Size(ZapisRejTab) && ZapisRejTab(index).idRejestr != xRejestr.id
		index += 1
	wend

	if index == Size(ZapisRejTab) then
		// dopisujemy nowy element do tablicy
		ZapisRejTab(index).idRejestr = xRejestr.id
		ZapisRejTab(index).strNazwa = xRejestr.kod
		ZapisRejTab(index).strDataOd = xRapPn.data
		ZapisRejTab(index).strDataDo = xRapPn.data
		ZapisRejTab(index).dKwota = xRapPn.wplaty + xRapPn.wyplaty
		ZapisRejTab(index).dSaldoPRK = xRapPn.otwarcie
		ZapisRejTab(index).dSaldoZRK = xRapPn.wplaty - xRapPn.wyplaty

		xTypDokumentuPn = GetObjById("BTypDokumentuPn", xRapPn.typDokumentu.id)
		if !xTypDokumentuPn then PrintError("Brak BTypDokumentuPn")
		ZapisRejTab(index).strObslJak =	xTypDokumentuPn.TypFK
		ZapisRejTab(index).strSymbolFK = xTypDokumentuPn.symbolFK
		// !!! kontoFK
		ZapisRejTab(index).strKonto	= xRejestr.kontoFK
		ZapisRejTab(index).strKod = xRapPn.numer

		ZapisRejTab(index).m_DekretParamsPn =xFactory.NewObject("BDekretParams")
		ZapisRejTab(index).m_DekretacjeRapPn = xFactory.NewObject("BDekretacjeRapPn")
		ZapisRejTab(index).m_DekretacjeRapPn.Clear()
		ZapisRejTab(index).m_DekretParamsPn = ZapisRejTab(index).m_DekretacjeRapPn.Params()
		ZapisRejTab(index).m_DekretParamsPn.id=xRapPn.id
		ZapisRejTab(index).m_DekretParamsPn.dodaj=0
		ZapisRejTab(index).m_DekretacjeRapPn.Dekret(ZapisRejTab(index).m_DekretParamsPn)

		Grow ZapisRejTab, 1 // zwikszamy dla zachowania zasady
	else
		// dodajemy do istniejcego elementu
		if xRapPn.data < ZapisRejTab(index).strDataOd then
			ZapisRejTab(index).strDataOd = xRapPn.data
			ZapisRejTab(index).dSaldoPRK = xRapPn.otwarcie
		endif
		if xRapPn.data > ZapisRejTab(index).strDataDo then
			ZapisRejTab(index).strDataDo = xRapPn.data
		endif
		ZapisRejTab(index).dKwota += xRapPn.wplaty + xRapPn.wyplaty
		ZapisRejTab(index).dSaldoZRK += xRapPn.wplaty - xRapPn.wyplaty

		ZapisRejTab(index).m_DekretParamsPn = ZapisRejTab(index).m_DekretacjeRapPn.Params()
		ZapisRejTab(index).m_DekretParamsPn.id=xRapPn.id
		ZapisRejTab(index).m_DekretParamsPn.dodaj=1
		ZapisRejTab(index).m_DekretacjeRapPn.Dekret(ZapisRejTab(index).m_DekretParamsPn)
	endif

	// dokumenty patnoci dla danego raportu
	for ii=1 to ii>xRj.Count()
		if xRj.item(ii).id==xRejestr.id then exit
	next ii

	xKartParamsDokPn.terminPlatnosci = xRapPn.data
	if ii<=xRj.Count() then xKartParamsDokPn.rejestr = xRj.item(ii)

	nRes = xDokPn.Load(xKartParamsDokPn)

	ii=1
	while !nRes && ii < xDokPn.Count()

		nRes = xDokumentPn.Load("id="+(using "%l",xDokPn.item(ii).id))

		if nRes then  PrintError("Brak takiego rekordu w bazie PN")
		if xDokumentPn.Wyplata == 0 || xDokumentPn.Wyplata == 1 then
			if 0 != xDokumentPn.danekh.KhID then
				select case xDokumentPn.danekh.KhTyp
					case 2 // pracownik
						EksportWR(xDokumentPn.danekh.KhID, 0)
					case 3 // urzad
						EksportUZ(xDokumentPn.danekh.KhID, 0)
					case 1 // kontrahent
						EksportKH(xDokumentPn.danekh.KhID, 0)
				endselect
			endif
		endif
		ii=ii+1
	wend
EndSub

int Sub EksportPN_zb_end()
	rozUidStrona = 0
	int index1

	index1 = 1
	while index1 < Size(ZapisRejTab)
		eksport.PoczatekPodsekcji("Dokument")

			eksport.Pole("symbol FK", ZapisRejTab(index1).strSymbolFK)
			eksport.Pole("kod", ZapisRejTab(index1).strKod)

			if ZapisRejTab(index1).strDataOd != ZapisRejTab(index1).strDataDo then
				eksport.Pole("opis FK", (Using "rejestr %s za dni od %s do %s", ZapisRejTab(index1).strNazwa, ZapisRejTab(index1).strDataOd, ZapisRejTab(index1).strDataDo))
			else
				eksport.Pole("opis FK", (Using "rejestr %s za dzie %s", ZapisRejTab(index1).strNazwa, ZapisRejTab(index1).strDataOd))
			endif

			eksport.Pole("dataWystawienia", ZapisRejTab(index1).strDataOd)
			eksport.Pole("dataSprzedazy", ZapisRejTab(index1).strDataOd)
			eksport.Pole("kwota", (Using "%.2f", ZapisRejTab(index1).dKwota))
			eksport.Pole("Sygnatura", xFactory.uzytkownik.kod)
			eksport.Pole("SaldoPRK", (Using "%.2f", ZapisRejTab(index1).dSaldoPRK))
			eksport.Pole("SaldoZRK", (Using "%.2f", ZapisRejTab(index1).dSaldoZRK))
			eksport.Pole("KontoKasy", ZapisRejTab(index1).strKonto)

			eksport.Pole("obsluguj jak", ZapisRejTab(index1).strObslJak)

			ZapiszZAP(ZapisRejTab(index1).m_DekretacjeRapPn, 0, IIF(ZapisRejTab(index1).strObslJak == "WB", 2, 3), "", 0, 0)

			ZapiszTRAROZ(ZapisRejTab(index1).m_DekretacjeRapPn, 1, 0)

		eksport.KoniecSekcji() //"Dokument"

		index1 += 1
	wend
EndSub