//"ekspZK.sci","Eksport ZK - include","\Eksport\Eksport include\",0,2.0.1,SYSTEM
/////////////////////////////////////////
// "Eksport ZK - include"
// ekspZK.sci
/////////////////////////////////////////

#include "Integracja ZK do FK - include3"

// dostpne opcje wywoania fukcji EksportZKbyDisp()
#define ROWNOLEGLE_KSIEG_MAG		0x1
#define NIE_EKSP_OZNAK				0x2

int DECLARE PrintError(String msg)
int DECLARE EksportZKbyDisp(dispatch xDokumentZkPar, int iOpcje)
int DECLARE EksportNumeriData(long lId, string strSekcja, int nDodatkowe)

int Sub EksportZK(long idZK, int iOpcje)
	EksportZK = 1

	dispatch xDokumentZKTmp

	int nRes = !(xDokumentZKTmp=GetObjById("BDokumentZk",idZK))
	if nRes then PrintError("Brak takiego rekordu w bazie DK")

	EksportZK = EksportZKbyDisp(xDokumentZKTmp, iOpcje)
EndSub

int Sub EksportZKbyDisp(dispatch xDokumentZkPar, int iOpcje)
	Dispatch dpRejestr, dpRejestrNP
	Dispatch dpStVat
	Dispatch xTypDokumentuZk
	Dispatch xKsSchematZk
	Dispatch xKonTmp
	Dispatch xDokumentMg
	Dispatch xKZ
	Dispatch xTmp

	EksportZKbyDisp = 1

	int nRes, ii, k, nZapCount
	int iStVat
	string sRejVat
	string sRejVatNazw
	int iRejVatRodz
	int iPom, iPomStVat
	int i
	int iSubtyp
	float sumanetto, sumavat
	string strObslugujJak
	String strOkres
	String strTmp
	long lABC
	int iNaliczony
	long tIdMG(1)
	int dokanul, bKorekta
	int nCzyWal
	float dKwota, dKurs
	int czyRelatedDokument = 0

	rozUidStrona = ROZ_STRONA_MA

	long idZK = xDokumentZkPar.id
	dokanul = iif(xDokumentZkPar.czyAnulowany, 1, 0)

	if !CzyPrzerwEkspBufor(xDokumentZkPar.czyWystawiony, xDokumentZkPar.numer) then
		EksportZKbyDisp = 0 // pomijamy
		Exit
	endif

	// sprawdzamy typ dokumentu
	Select Case xDokumentZkPar.charakter
		Case FVZ, FKZ, RUZ, RKZ, DIM, DKM, ZRZ, ZRK, FVR, FKR, ANUL, FVM, FKM, FZZ, ZKZ, WNT, FWZ, WKZ, WNK, ZVW, ZWK
		Case Else
			EksportZKbyDisp = 0 // pomijamy
			eksport.AddError("Nie mona wyeksportowa dokumentu " + xDokumentZkPar.numer + ". Dokument tego typu jest nieeksportowalny.")
	EndSelect
	if ( EksportZKbyDisp == 0 ) then Exit

	if !dokanul && !CzyEkspBrakSchematu(xDokumentZkPar.schematKsiegowania, xDokumentZkPar.numer) then
		EksportZKbyDisp = 0 // pomijamy
		Exit
	endif

	xKsSchematZk = GetObjByKod("BKsSchematZk", xDokumentZkPar.schematKsiegowania)
	if xKsSchematZk then
		nRes = 0
	else
		nRes = 1
	endif

	if !dokanul && !CzyEkspBlednySchemat(nRes, xDokumentZkPar.numer) then
		EksportZKbyDisp = 0 // pomijamy
		Exit
	endif

	xTypDokumentuZk = GetObjByKod("BTypDokumentuZk", xDokumentZkPar.typDk)
	if xTypDokumentuZk then
		if(xTypDokumentuZk.typFK == "FVS" || xTypDokumentuZk.typFK == "RUS" || xTypDokumentuZk.typFK == "FVZ" ||xTypDokumentuZk.typFK == "RUZ" || xTypDokumentuZk.typFK == "FVSM" || xTypDokumentuZk.typFK == "FVT") then
		 	czyRelatedDokument = 1
		else
			czyRelatedDokument = 0
		endif
		xDokumentZkPar.SprawdzUzgodnienieFK()
		nRes = 0
	else
		nRes = 1
	endif

	if !dokanul && !CzyEkspBrakTypDK(nRes, xDokumentZkPar.numer, xDokumentZkPar.charakter, xDokumentZkPar.typDk) then
		EksportZKbyDisp = 0 // pomijamy
		Exit
	endif

	iSubtyp = xDokumentZkPar.charakter
	//sprawdzamy czy faktury walutowe nie sa eksportowane jako stare( nie walutowe) do FK
	if(iSubtyp == ZVW || iSubtyp == ZWK)  && (xTypDokumentuZk.typFK != "FWZ" && xTypDokumentuZk.typFK != "FWZK") && (xDokumentZkPar.kurs != xDokumentZkPar.kursDoch) then
		nRes = 1
	else
		nRes = 0
	endif
	if !dokanul && !CzyEkspBlednyTypFK(nRes, xDokumentZkPar.numer) then
		EksportZKbyDisp = 0 // pomijamy
		Exit
	endif
/*
	//sprawdzamy czy dokumenty zlotowkowe nie sa eksportowane jako faktura walutowa
	if (xTypDokumentuZk.typFK == "FWZ" || xTypDokumentuZk.typFK == "FWZK") && (xDokumentZkPar.waluta == "") then
	nRes = 1
	else
		nRes = 0
	endif
	if !dokanul && !CzyEkspBlednyTypFK2(nRes,xDokumentZkPar.numer, xDokumentZkPar.charakter) then
		EksportZKbyDisp = 0 // pomijamy
		Exit
	endif
*/
	dpRejestrNP = xTypDokumentuZk.rejestrNP
	if ( xDokumentZkPar.czyKorekta ) then bKorekta = 1
	eksport.PoczatekSekcji("Dokument", idZK)
		eksport.Pole("uid", xDokumentZkPar.guid)//teraz zawsze wysyamy guid dokumentu

		eksport.Pole("anulowany", using "%d",dokanul)
		eksport.Pole("rodzaj_dok", "zakupu")
		if (iSubtyp == WNT || iSubtyp == FWZ || iSubtyp == FVR || iSubtyp == FKR || iSubtyp == WKZ || iSubtyp == WNK) then
			eksport.Pole("metoda_VAT", "2")
		endif

		if ((xDokumentZkPar.charakter == FVR) || (xDokumentZkPar.charakter == FKR)) then
			eksport.Pole("naliczenie_VAT", "5")
		else
			if (xDokumentZkPar.metodaVAT) then
				eksport.Pole("naliczenie_VAT", "11")
			else
				if ((xDokumentZkPar.charakter == FVM) || (xDokumentZkPar.charakter == FKM)) then
					eksport.Pole("naliczenie_VAT", "11")
				else
					eksport.Pole("naliczenie_VAT", "0")
				endif
			endif
		endif

    	if ( iSubtyp != FWZ && iSubtyp != WKZ) then   //pomijamy faktury wewntrzne
			eksport.Pole("rejestr_platnosci", xDokumentZkPar.rejestr.kod)
			eksport.Pole("forma_platnosci", PoleFormaPlatnosci(xDokumentZkPar.formaPl))
        endif

		eksport.PoczatekPodsekcji("Dane sprzedawcy")
			eksport.Pole("khid", (Using "%l", xDokumentZkPar.danekh.KhID))
			xKonTmp = KonFullGetByKod(xDokumentZkPar.danekh.KhKod, xDokumentZkPar.danekh.KhTyp)
			if !nRes then eksport.Pole("fk_ident", xKonTmp.identyfikatorFK)
			eksport.Pole("khkod", xDokumentZkPar.danekh.KhKod)
			eksport.Pole("khnazwa", xDokumentZkPar.danekh.KhNazwa)
			eksport.Pole("KhUlica", xDokumentZkPar.danekh.KhUlica)
			eksport.Pole("KhDomu", xDokumentZkPar.danekh.KhDomu)
			eksport.Pole("KhLokal", xDokumentZkPar.danekh.KhLokal)
			eksport.Pole("khmiasto", IIF(Len(xDokumentZkPar.danekh.KhMiasto) > lenMIASTO, Mid(xDokumentZkPar.danekh.KhMiasto,0,lenMIASTO), xDokumentZkPar.danekh.KhMiasto))
			eksport.Pole("khkodpocz", xDokumentZkPar.danekh.KhPoczta)
			eksport.Pole("khnip", xDokumentZkPar.danekh.KhNIP)
			if 0 != xDokumentZkPar.danekh.KhID then
				EksportKH(xDokumentZkPar.danekh.KhID, 0)
			endif
		eksport.KoniecSekcji() //"Dane sprzedawcy"

		xDekretacjeZk.Clear()
		xDekretParamsZk = xDekretacjeZk.Params()
		xDekretParamsZk.id=xDokumentZkPar.id
		xDekretParamsZk.RownolegleMAG = (iOpcje & ROWNOLEGLE_KSIEG_MAG)
		xDekretParamsZk.czyEkspOznak = !(iOpcje & NIE_EKSP_OZNAK)
		xDekretacjeZk.Dekret(xDekretParamsZk)

		nCzyWal = 0
		if xDokumentZkPar.GetRozrachunek() then
			nCzyWal = CzyWalutowy(xDokumentZkPar.GetRozrachunek().id)
		endif

		if nCzyWal then
			if(xTypDokumentuZk.typFK == "FWZ" || xTypDokumentuZk.typFK == "FWZK")  then //nowy typ dokumentu w FK - wielowalutowy
				eksport.PoczatekPodsekcji("AtrybutWaluta")
					eksport.Pole("kurs", (Using "%.12f", xDokumentZkPar.kursDoch))
					eksport.Pole("waluta", xDokumentZkPar.waluta)
					eksport.Pole("dane","kurs CIT/PIT")
				eksport.KoniecSekcji() //"AtrybutWaluta"
				eksport.PoczatekPodsekcji("AtrybutWaluta")
					eksport.Pole("kurs", (Using "%.12f", xDokumentZkPar.kurs))
					eksport.Pole("waluta", xDokumentZkPar.waluta)
					eksport.Pole("dane","kurs VAT")
				eksport.KoniecSekcji() //"AtrybutWaluta"
				eksport.Pole("wkwota", (Using "%.2f", xDokumentZkPar.wysokoscNaleznosci))
			else
				dKurs = xDokumentZkPar.kurs
				eksport.Pole("kurs", (Using "%.12f", dKurs))
				eksport.Pole("waluta", xDokumentZkPar.waluta)

				dKwota = xDokumentZkPar.wysokoscNaleznosci
				eksport.Pole("wkwota", (Using "%.2f", dKwota))
				eksport.Pole("kwota", (Using "%.2f", Round(dKwota * dKurs, 2)))
			endif
		else
			if ( xDokumentZkPar.charakter == DIM || xDokumentZkPar.charakter == DKM || xDokumentZkPar.charakter == WNT || xDokumentZkPar.charakter == WNK ) then
				// w tym wypadku dKwota zawiera ca, akcyzy i inne, a nie powinna

				dKwota = 0
				nZapCount = xDekretacjeZk.zapisy.Count()

				for ii=1 to ii > nZapCount
					if !xDekretacjeZk.zapisy.item(ii).ma then
						dKwota += xDekretacjeZk.zapisy.item(ii).kwota
					endif
				next ii

				eksport.Pole("kwota", (Using "%.2f", dKwota))
			else
				dKwota = xDokumentZkPar.netto + xDokumentZkPar.niePodlega + xDokumentZkPar.vat
				eksport.Pole("kwota", (Using "%.2f", dKwota))
			endif
		endif

		// "symbol FK" i "obsuguj jak"
		eksport.Pole("symbol FK", xTypDokumentuZk.symbolFK)
		strObslugujJak = xTypDokumentuZk.TypFK
		eksport.Pole("obsluguj jak", strObslugujJak)

		eksport.Pole("dataWystawienia", xDokumentZkPar.dataWystawienia)
		if ( xDokumentZkPar.charakter == FWZ || xDokumentZkPar.charakter == WKZ) then	// || xDokumentZkPar.charakter == DIM || xDokumentZkPar.charakter == DKM) then
			eksport.Pole("dataZakupu", xDokumentZkPar.dataWystawienia)
		else
			eksport.Pole("dataZakupu", xDokumentZkPar.dataZakupu)
			eksport.Pole("dataWystawieniaObca", xDokumentZkPar.dataWystawieniaObca)
		endif

		eksport.Pole("terminPlatnosci", xDokumentZkPar.terminPlatnosci)
		if bKorekta then
			if xDokumentZkPar.czyKZ then	//korekta zbiorcza
				xKZ = xDokumentZkPar.dokumentyKorygowaneKZ
				k = 1
				for k to k > xKZ.Count
					EksportNumeriData(xKZ.item(k).id, "Dokument korygowany", 0)
				next k
			else
				// musimy siegnac do dokumentu korygowanego pierwotnego
				// numer i data dokumentu korygowanego
				// przyjete ze jest to pierwszy w kolekcji
				if xDokumentZkPar.DokumentZKorektami.Count() && xDokumentZkPar.DokumentZKorektami.item(1).Numer!= xDokumentZkPar.Numer then
					EksportNumeriData(xDokumentZkPar.DokumentZKorektami.item(1).id, "Dokument korygowany", 1)
				endif
			endif
		else
			if xDokumentZkPar.DokumentZKorektami.Count() && xDokumentZkPar.DokumentZKorektami.item(1).Numer== xDokumentZkPar.Numer then
				k = 2
				for k to k > xDokumentZkPar.DokumentZKorektami.Count()
					EksportNumeriData(xDokumentZkPar.DokumentZKorektami.item(k).id, "Korekta dokumentu", 0)
				next k
			endif
		endif

		// split payment
		eksport.Pole("mppFlags", (using "%d", xDokumentZkPar.mppFlags))
		eksport.Pole("JPK_V7", xDokumentZkPar.JPK_V7)
		eksport.Pole("rachunek", xDokumentZkPar.accountNo)

		// pozycje dokumentu
		dispatch pozycja
		for ii=1 to ii>xDokumentZkPar.Pozycje.Count()
			if ((!xDokumentZkPar.CzyKorekta) || (xDokumentZkPar.CzyKorekta && xDokumentZkPar.Pozycje.item(ii).wlasna)) then
				if (xDokumentZkPar.CzyKorekta) then
					if (xDokumentZkPar.Pozycje.item(ii).idpozkoryg) then
						pozycja = xDokumentZkPar.Pozycje.item(ii).przedKorekta
						dpRejestr = pozycja.rejestrVAT
						dpStVat = pozycja.stVAT
						if (xDokumentZkPar.charakter == WKZ) then
							// dla faktury wewntrznych dostajemy GetDispObject(FiREJVATSP, ppcszValue, ppRow);
							iNaliczony = 0
							lABC = 1
						else
							iNaliczony = 1
							lABC = dpRejestr.typ
						endif
						TabRejVat.Wstaw(dpRejestr, dpStVat, pozycja, lABC, iNaliczony, 1)
						if pozycja.czyVat50 then
							dpStVat = GETxStawkaObjectByIdentifier(GETIDxVATNP())
							TabRejVat.Wstaw(dpRejestrNP, dpStVat, pozycja, lABC, iNaliczony, 1)
						endif
					endif

					pozycja = xDokumentZkPar.Pozycje.item(ii).poKorekcie
					dpRejestr = pozycja.rejestrVAT
					if (xDokumentZkPar.charakter == WKZ) then
						iNaliczony = 0
						lABC = 1
					else
						iNaliczony = 1
						lABC = dpRejestr.typ
					endif
					dpStVat = pozycja.stVAT
					TabRejVat.Wstaw(dpRejestr, dpStVat, pozycja, lABC, iNaliczony, 0)
					if pozycja.czyVat50 then
						dpStVat = GETxStawkaObjectByIdentifier(GETIDxVATNP())
						TabRejVat.Wstaw(dpRejestrNP, dpStVat, pozycja, lABC, iNaliczony, 0)
					endif
				else
					pozycja = xDokumentZkPar.Pozycje.item(ii)
					dpRejestr = pozycja.rejestrVAT
					if (xDokumentZkPar.charakter == FWZ) then
						iNaliczony = 0
						lABC = 1
					else
						iNaliczony = 1
						lABC = dpRejestr.typ
					endif
					dpStVat = pozycja.stVAT
					TabRejVat.Wstaw(dpRejestr, dpStVat, pozycja, lABC, iNaliczony, 0)
					if pozycja.czyVat50 then
						dpStVat = GETxStawkaObjectByIdentifier(GETIDxVATNP())
						TabRejVat.Wstaw(dpRejestrNP, dpStVat, pozycja, lABC, iNaliczony, 0)
					endif
				endif

				if (xDokumentZkPar.charakter == FWZ || xDokumentZkPar.charakter == WKZ) then
					if (xDokumentZkPar.CzyKorekta) then
						if (xDokumentZkPar.Pozycje.item(ii).idpozkoryg) then
							pozycja = xDokumentZkPar.Pozycje.item(ii).przedKorekta
							dpRejestr = pozycja.rejVATnalicz
							lABC = dpRejestr.typ
							dpStVat = pozycja.stVAT
							TabRejVat.Wstaw(dpRejestr, dpStVat, pozycja, lABC, 1, 1)
						endif

						pozycja = xDokumentZkPar.Pozycje.item(ii).poKorekcie
						dpRejestr = pozycja.rejVATnalicz
						lABC = dpRejestr.typ
						dpStVat = pozycja.stVAT
						TabRejVat.Wstaw(dpRejestr, dpStVat, pozycja, lABC, 1, 0)
					else
						pozycja = xDokumentZkPar.Pozycje.item(ii)
						dpRejestr = pozycja.rejVATnalicz
						lABC = dpRejestr.typ
						dpStVat = pozycja.stVAT
						TabRejVat.Wstaw(dpRejestr, dpStVat, pozycja, lABC, 1, 0)
					endif
				endif

				if (xDokumentZkPar.czyDrugiRej) then
					if (xDokumentZkPar.CzyKorekta) then
						if (xDokumentZkPar.Pozycje.item(ii).idpozkoryg) then
						pozycja = xDokumentZkPar.Pozycje.item(ii).przedKorekta
							dpRejestr = pozycja.rejestrVATnalezny
							if (dpRejestr && dpRejestr.id) then
								dpStVat = pozycja.stVAT
								TabRejVat.Wstaw(dpRejestr, dpStVat, pozycja, 1, 0, 1)
							endif
						endif
						pozycja = xDokumentZkPar.Pozycje.item(ii).poKorekcie
						dpRejestr = pozycja.rejestrVATnalezny
						if (dpRejestr && dpRejestr.id) then
							dpStVat = pozycja.stVAT
							TabRejVat.Wstaw(dpRejestr, dpStVat, pozycja, 1, 0, 0)
						EndIf
					else
					pozycja = xDokumentZkPar.Pozycje.item(ii)
						dpRejestr = pozycja.rejestrVATnalezny
						if (dpRejestr && dpRejestr.id) then
							dpStVat = pozycja.stVAT
							TabRejVat.Wstaw(dpRejestr, dpStVat, pozycja, 1, 0, 0)
						EndIf
					endif
				endif
			endif
		next ii

		// eksport do jpk
		eksport.Pole( "jpk", ( Using "%d", xDokumentZkPar.jpk ) )

		//////////////////////////////////////////////////////
		// numer dokumentu w FK
		strTmp = OdczytajKodObcy( xDokumentZkPar.id, xDokumentZkPar.charakter, xDokumentZkPar.numerObcy )
		strTmp += " ["
		strTmp += xDokumentZkPar.numer
		strTmp += "]"
		strTmp = Mid(strTmp, 1, iif(len(strTmp)>40,40,len(strTmp)))
		eksport.Pole("FK nazwa", strTmp)

		//na potrzeby MKP
		eksport.Pole("kod", xDokumentZkPar.numer)
		eksport.Pole("kod_obcy", xDokumentZkPar.numerObcy)
		eksport.Pole("od_brutto", IIF( xDokumentZkPar.rodzajCeny == 1, "1", "0" ))

		eksport.Pole("typ_dk", xDokumentZkPar.typDk )
		eksport.Pole("seria", xDokumentZkPar.seria )
		eksport.Pole("serianr", (Using "%l", xDokumentZkPar.numerWSerii))
		eksport.Pole("okres", (Using "%d", xDokumentZkPar.okresNumeracji))
		eksport.Pole("dzial", (Using "%l", xDokumentZkPar.dzial.id))
		EksportNotatka(xDokumentZkPar.Notatka, "notatka")
		If (!xDokumentZkPar.czyAnulowany) Then
			xTmp = xDokumentZkPar.rozrachunekDk
			If (xTmp) Then
				Eksport_RozrachunekDok(xTmp, 0)
			EndIf
			Eksport_RozliczenieDok(xDokumentZkPar.rozrachunekDk)
		EndIf

		// rwnolege ksigowania magazynowe - sprawdzenie
		if iOpcje & ROWNOLEGLE_KSIEG_MAG then
			if bKorekta then
				for ii=1 to ii>xDokumentZkPar.zwiazkiOdpDok.Count()
					if ((xDokumentZkPar.zwiazkiOdpDok.item(ii).dkBase == 33) && xDokumentZkPar.zwiazkiOdpDok.item(ii).idDk) then
						nRes=!(xDokumentMg=GetObjById("BDokumentMg",xDokumentZkPar.zwiazkiOdpDok.item(ii).idDk))
						if nRes then  error "Dokument nie zaadowany"
						if xDokumentMg.czyWystawiony && xDokumentMg.czyZatwWart then // czy wystawiony i zatwierdzony wartosciowo
							if !( !((iOpcje & NIE_EKSP_OZNAK) && xDokumentMg.czyWyeksportFK) ) then
								eksport.AddInfo("Nie mona powtrnie wyeksportowa zapisw do dokumentu " + xDokumentMg.numer + ".")
							endif
						endif
					endif
				next ii
			else
				for ii=1 to ii>xDokumentZkPar.transakcjaTw.powiazaniaTw.Count()
					nRes=!(xDokumentMg=GetObjById("BDokumentMg",xDokumentZkPar.transakcjaTw.powiazaniaTw.item(ii).idWlascicielaTrans))
					if nRes then  error "Dokument nie zaadowany"
					if xDokumentMg.czyWystawiony && xDokumentMg.czyZatwWart then // czy wystawiony i zatwierdzony wartosciowo
						if !( !((iOpcje & NIE_EKSP_OZNAK) && xDokumentMg.czyWyeksportFK) ) then
							eksport.AddInfo("Nie mona powtrnie wyeksportowa zapisw do dokumentu " + xDokumentMg.numer + ".")
						endif
					endif
				next ii
			endif
		endif // rwnolege ksigowania magazynowe

		if ( xDokumentZkPar.charakter == FWZ || xDokumentZkPar.charakter == WKZ) then // || xDokumentZkPar.charakter == DIM || xDokumentZkPar.charakter == DKM) then
			eksport.Pole("Datawpl", xDokumentZkPar.dataWystawienia)
		else
			eksport.Pole("Datawpl", xDokumentZkPar.dataWplywu)
		endif

		eksport.Pole("opis FK",	xDekretacjeZk.trescwFK)

		if(xTypDokumentuZk.typFK == "FWZ" || xTypDokumentuZk.typFK == "FWZK")  then //nowy typ dokumentu w FK - wielowalutowy
			//ewentualne rownolegle ksiegowanie magazynowe tylko w PLN
			ZapiszZAP(xDekretacjeZk, 0, 0, "", 0, !czyRelatedDokument)
		else
			ZapiszZAP(xDekretacjeZk, 0, nCzyWal, xDokumentZkPar.waluta, xDokumentZkPar.kurs, !czyRelatedDokument)
		endif

		ZapiszETRANSFERS(xDokumentZkPar, xDekretacjeZk)

		// rejestry VAT
		iSubtyp = xDokumentZkPar.charakter
		Select Case iSubtyp
			Case FVZ, FKZ, RUZ, RKZ, DIM, DKM, FVR, FKR, ZRZ, ZRK, FVM, FKM, FZZ, ZKZ, WNT, FWZ, WKZ, WNK
				//nic nie rb
			Case Else
				if strObslugujJak == "FVZ" || strObslugujJak == "RUZ" then
					iSubtyp = 1000
				endif
		EndSelect

		Select Case iSubtyp
			Case FVZ, FKZ, RUZ, RKZ, FVR, FKR, 1000, FVM, FKM, FZZ, ZKZ, WNT, FWZ, WKZ, WNK, ZRZ, ZRK, ZVW, ZWK
				for iPom=1 to iPom>TabRejVat.IloscRejestrow(0)
					for iPomStVat=1 to iPomStVat>TabRejVat.IloscStawek(iPom)
						eksport.PoczatekPodsekcji("Rejestr")
							// ABC
							eksport.Pole("skrot", TabRejVat.RejVat(iPom).Skrot)
							eksport.Pole("Nazwa", TabRejVat.RejVat(iPom).Nazwa)
							eksport.Pole("Rodzaj", (using "%d",TabRejVat.RejVat(iPom).Rodzaj))
							eksport.Pole("Naliczony", (using "%d",TabRejVat.RejVat(iPom).Naliczony))
							eksport.Pole("JPK_V7", TabRejVat.RejVat(iPom).JPK_V7)
							select case TabRejVat.RejVat(iPom).ABCD
								case 2,4,8
									eksport.Pole("ABC", using"%d",TabRejVat.RejVat(iPom).ABCD)
								case else
									eksport.Pole("ABC", "1")
							endselect
							if (iSubtyp == WNT || iSubtyp == FWZ || iSubtyp == FVR || iSubtyp == FKR || iSubtyp == WKZ || iSubtyp == WNK) then
								eksport.Pole("metoda_VAT", "2")
							endif

							// okres
							if ((iSubtyp == FWZ || iSubtyp == WKZ) && TabRejVat.RejVat(iPom).Naliczony) then	//tylko f-ra wewntrzna ma drug dat rejestru
								eksport.Pole("datarej", xDokumentZkPar.dataRejVATnalicz)	//dla maej ksigowoci
								buf = xDokumentZkPar.dataRejVATnalicz
							else
								eksport.Pole("datarej", xDokumentZkPar.dataRejestrVAT)	//dla maej ksigowoci
								buf = xDokumentZkPar.dataRejestrVAT
							endif
							strOkres = Find Regular "????????" // osiem pierwszych znakw
							eksport.Pole("okres", (strOkres + "01"))
							// okres

							eksport.Pole("stawka", (Using "%.0f", TabRejVat.Wartosc(iPom, iPomStVat, "stawka")))
							eksport.Pole("brutto", (Using "%.2f", Round( (TabRejVat.Wartosc(iPom, iPomStVat, "netto") + TabRejVat.Wartosc(iPom, iPomStVat, "vat")),2 )))
							eksport.Pole("netto", (Using "%.2f", Round( TabRejVat.Wartosc(iPom, iPomStVat, "netto"),2 )))
							eksport.Pole("vat", (Using "%.2f", Round( TabRejVat.Wartosc(iPom, iPomStVat, "vat"),2 )))
							//eksport.Pole("sumanetto", (Using "%.2f", Round( TabRejVat.RejVat(iPom).SumNetto,2 )))
							//eksport.Pole("sumavat", (Using "%.2f", Round( TabRejVat.RejVat(iPom).SumVat,2 )))

							if(nCzyWal &&(xTypDokumentuZk.typFK == "FWZ" || xTypDokumentuZk.typFK == "FWZK"))  then //nowy typ dokumentu w FK - wielowalutowy
								eksport.Pole("bruttoWaluta", (Using "%.2f", Round(TabRejVat.Wartosc(iPom, iPomStVat, "wbrutto"),2 )))
								eksport.Pole("nettoWaluta", (Using "%.2f", Round( TabRejVat.Wartosc(iPom, iPomStVat, "wnetto"),2 )))
								eksport.Pole("vatWaluta", (Using "%.2f", Round((TabRejVat.Wartosc(iPom, iPomStVat, "wbrutto") - TabRejVat.Wartosc(iPom, iPomStVat, "wnetto")),2 )))
							endif
						eksport.KoniecSekcji() //"Rejestr"
					next iPomStVat
				next iPom

			Case DIM, DKM
				for iPom=1 to iPom>TabRejVat.IloscRejestrow(0)
					eksport.PoczatekPodsekcji("Rejestr")
						// ABC
						eksport.Pole("skrot", TabRejVat.RejVat(iPom).Skrot)
						eksport.Pole("Nazwa", TabRejVat.RejVat(iPom).Nazwa)
						eksport.Pole("JPK_V7", TabRejVat.RejVat(iPom).JPK_V7)
						eksport.Pole("Rodzaj", (using "%d",TabRejVat.RejVat(iPom).Rodzaj))
						eksport.Pole("Naliczony", (using "%d",TabRejVat.RejVat(iPom).Naliczony))
						// okres
						eksport.Pole("datarej", xDokumentZkPar.dataRejestrVAT)	//dla maej ksigowoci
						buf = xDokumentZkPar.dataRejestrVAT
						strOkres = Find Regular "????????" // osiem pierwszych znakw
						eksport.Pole("okres", (strOkres + "01"))

						select case TabRejVat.RejVat(iPom).ABCD
							case 2
								eksport.Pole("ABC", using"%d",TabRejVat.RejVat(iPom).ABCD)

							case 4
								eksport.Pole("ABC", using"%d",TabRejVat.RejVat(iPom).ABCD)

							case 8
								eksport.Pole("ABC", using"%d",TabRejVat.RejVat(iPom).ABCD)

							case else
								eksport.Pole("ABC", "1")

						endselect

						eksport.Pole("stawka", (Using "%.0f", -3))
						eksport.Pole("brutto", (Using "%.2f", Round( TabRejVat.RejVat(iPom).SumNetto+TabRejVat.RejVat(iPom).SumVat,2 )))
						eksport.Pole("netto", (Using "%.2f", Round( TabRejVat.RejVat(iPom).SumNetto,2 )))
						eksport.Pole("vat", (Using "%.2f", Round( TabRejVat.RejVat(iPom).SumVat,2 )))
						//eksport.Pole("sumanetto", (Using "%.2f", Round( TabRejVat.RejVat(iPom).SumNetto,2 )))
						//eksport.Pole("sumavat", (Using "%.2f", Round( TabRejVat.RejVat(iPom).SumVat,2 )))

					eksport.KoniecSekcji() //"Rejestr"
				next iPom
		EndSelect
		TabRejVat.IloscRejestrow(-1)
		TabRejVat.ClearRec()

		ZapiszTRAROZ(xDekretacjeZk, 0, xDokumentZkPar.kurs)

	eksport.KoniecSekcji() //"Dokument"
EndSub

int sub EksportNumeriData(long lId, string strSekcja, int nDodatkowe)
	int nRes = 0
	String strTmp
	EksportNumeriData = 0

	nRes=!(xDokumentZkKoryg=GetObjById("BDokumentZk",lId))
	if nRes then Error "Brak takiego rekordu w bazie DK"
		strTmp = xDokumentZkKoryg.numerObcy
		strTmp += " ["
		strTmp += xDokumentZkKoryg.Numer
		strTmp += "]"
		strTmp = Mid(strTmp, 1, iif(len(strTmp)>40,40,len(strTmp)))

		if nDodatkowe then
			eksport.Pole("NazwaKor", strTmp)
			eksport.Pole("DataKor", xDokumentZkKoryg.dataZakupu)
		endif

		eksport.PoczatekPodsekcji(strSekcja)
			eksport.Pole("guid", xDokumentZkKoryg.guid)
			eksport.Pole("kod", strTmp)
			eksport.Pole("data",xDokumentZkKoryg.dataWystawieniaObca)
		eksport.KoniecSekcji()

	EksportNumeriData = nRes
endsub
