//"intemgfk.sci","Integracja MG do FK - include","\Integracja z FK a\",0,1.0.0,SYSTEM
/////////////////////////////////////////
// "Integracja MG do FK - include"
// intemgfk.sci
#define APOSTROF "\t"
#define AUTOTRANS_ITG 4

int Sub IntegrMG(long idDK)

	IntegrMG = 0

	string sTyp
	int err
	String strKonto
	float dWartosc
	int nCount
	int nPozycja = 0
	int index
	int iRok
	long ii
	Dispatch xKontrahent
	Dispatch xDokMg
	Dispatch xTypDokumentuMg
	Dispatch xKsSchematMg

	Dispatch xIntegracja = xFactory.GetObject("BIntegracjaFK")

	nRes=!(xDokumentMg=GetObjById("BDokumentMg",idDK))
	if nRes then  Error "Brak takiego rekordu w bazie MG"

	iRok = dbd.firmainfo.GetRokByDate(xDokumentMg.dataWystawienia)
	if RokFK(1).Zap == 1 then

		if RokFK(1).IdRok != iRok then
			UstawRok(iRok)
		endif

	else
		UstawRok(iRok)
	endif

	dst=RokFK(1).Rok
	plkn=RokFK(1).PlanKont
	defdok=RokFK(1).DefDokument
	rozrDokument=RokFK(1).RokDokumentRoz

	// sprawdzamy typ dokumentu
	Select Case xDokumentMg.charakter
		Case PW, PWK, RW, RWK, WZM, WZK, PZM, PZK, MMP, MKP, MMM, MKM, KWM, PWM, WDP, WPK, PZP, PPK
		Case Else
			IntegrMG = 1 // pomijamy
			AddError("Nie mona wysa dokumentu " + xDokumentMg.numer+".",idDK)
	EndSelect
	if ( IntegrMG == 1 ) then Exit

	if CzyIntegrBrakSchematu(xDokumentMg.schematKsiegowania, xDokumentMg.numer, idDK) then
		IntegrMG = 1 // pomijamy
		Exit
	endif

	xKsSchematMg = GetObjByKod("BKsSchematMg", xDokumentMg.schematKsiegowania)
	if xKsSchematMg then
		nRes = 0
	else
		nRes = 1
	endif

	if CzyIntegrBlednySchemat(nRes, xDokumentMg.numer, idDK) then
		IntegrMG = 1 // pomijamy
		Exit
	endif

	if IntegrZatwWart(xDokumentMg, "", 1) then
		IntegrMG = 1 // pomijamy
		Exit
	endif

	sTyp = xDokumentMg.typDk

	nRes = !(xDokMg=GetObjById("BDokMg",idDK))
	if nRes then  error "Dokument nie zaadowany"

	if xDokMg.czyZaimport then
		//dokument moze miec typ dokumentu wprowadzony tylko w centrali
		// sprawdzamy czy ma taki typ
		xTypDokumentuMg = GetObjByKod("BTypDokumentuMg", xDokumentMg.typDk)
		sTyp = ""
		if xTypDokumentuMg && (xDokumentMg.charakter == xTypDokumentuMg.charakter) then
			// typ dokumentu pasuje z odzdialu z centrala
			sTyp = xDokumentMg.typDk
		else
			// nie znaleizono typu o takim kodzie wiec
			// szukamy dla podstawowego typu dla charakteru dokumentu
			xTypDokumentuMg = GetObjByKod("BTypDokumentuMg", TypDOK(xDokumentMg.charakter))
			if xTypDokumentuMg && (xDokumentMg.charakter == xTypDokumentuMg.charakter) then
				sTyp = xDokumentMg.typDk
			else
				IntegrMG = CzyIntegrBrakTypDK("", xDokumentMg.numer, idDK, TypDOK(xDokumentMg.charakter))
			endif
		endif
	endif
	if !(xDokMg.czyZaimport) || ((xDokMg.czyZaimport) && sTyp != "") then
		xTypDokumentuMg = GetObjByKod("BTypDokumentuMg", sTyp)
		if !xTypDokumentuMg then  error "Brak takiego rekordu"

		IntegrMG = CzyIntegrBrakTypDK(xTypDokumentuMg.symbolFK, xDokumentMg.numer, idDK, sTyp)
	endif

	if IntegrMG then exit

	dst.Clear()
	sOpisy=0
	dbd.CurrentDate = sDataWpr
	//sposb wsppracy z FK
	if(xIntegracja.currentLoadNewVersion) then//obiekt integracji obsuguje guidy rozrachunkw
		dst.Value("UId") = xDokumentMg.guid
	endif
	dst.Value("DataDok") = xDokumentMg.dataWystawienia
//	dst.Value("DataOkr") = xDokumentMg.dataWystawienia
	dst.Value("DataOper") = xDokumentMg.dataOperacji
	dst.Value("Datawpl") = Data()
	dst.Value("Datawpr") = sDataWpr
	dst.Value("Kwota") = Round( (xDokumentMg.wartosc),2 )

/////////////////// specjalna obsuga dokumentw przyjcia wewntrzwsplnotowego - wysylany jest kontrahent /////////////
	if xDokumentMg.danekh.KhId != 0 then
		xKontrahent = GetObjById("BKontrahent", xDokumentMg.danekh.KhId)
		if !xKontrahent then  error "Brak takiego rekordu w bazie KH"

		if ( 1 == xIntegracja.trybWspolpracy || 4 == xIntegracja.trybWspolpracy) then
			dst.Value("kontrahent") = xKontrahent.guid
		else
			dst.Value("kontrahent") = val(xKontrahent.identyfikatorFK)
		endif
	endif
	if xDokumentMg.danekh.KhKod == "" && xDokumentMg.danekh.KhNazwa != "" then
		kontrah.ClearRecord()
		kontrah.Value("nazwa") = xDokumentMg.danekh.KhNazwa
		kontrah.Value("nip") = xDokumentMg.danekh.KhNIP
		kontrah.Value("ulica") = xDokumentMg.danekh.KhUlica
		kontrah.Value("nrDomu") = xDokumentMg.danekh.KhDomu
		kontrah.Value("nrMieszkania") = xDokumentMg.danekh.KhLokal
		kontrah.Value("miejscowosc") = xDokumentMg.danekh.KhMiasto
		kontrah.Value("kodPocztowy") = xDokumentMg.danekh.KhPoczta

		if !kontrah.CheckIfExists() then
			if kontrah.Validate() && (IntegrMG == 0) then
				if !kontrah.Insert() && kontrah.CheckIfExists() then
					if ItgInfo.Info("PlanKontSubjectType") then
						dst.Value("kontrahent") = kontrah.GetExistingPoz(0)
					else
						dst.Value("kontrahent") = kontrah.GetExistingId(0)
					endif
				endif
			endif
		else
			if ItgInfo.Info("PlanKontSubjectType") then
				dst.Value("kontrahent") = kontrah.GetExistingPoz(0)
			else
				dst.Value("kontrahent") = kontrah.GetExistingId(0)
			endif
		endif
	endif
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	sTyp = xDokumentMg.typDk
	if xDokMg.czyZaimport then
		//dokument moze miec typ dokumentu wprowadzony tylko w centrali
		// sprawdzamy czy ma taki typ
		xTypDokumentuMg = GetObjByKod("BTypDokumentuMg", xDokumentMg.typDk)
		sTyp = ""
		if xTypDokumentuMg && (xDokumentMg.charakter == xTypDokumentuMg.charakter) then
			// typ dokumentu pasuje z odzdialu z centrala
			sTyp = xDokumentMg.typDk
		else
			// nie znaleizono typu o takim kodzie wiec
			// szukamy dla podstawowego typu dla charakteru dokumentu
			xTypDokumentuMg = GetObjByKod("BTypDokumentuMg", TypDOK(xDokumentMg.charakter))
			if xTypDokumentuMg && (xDokumentMg.charakter == xTypDokumentuMg.charakter) then

				sTyp = xDokumentMg.typDk
			else
				error "Brak takiego rekordu w bazie DK"
			endif
		endif
	endif
	// w sumie mogloby nie byc tego wraunku bo styp musi byc
//		if !(xDokMg.item(1).czyZaimport) || ((xDokMg.item(1).czyZaimport) && sTyp != "") then
		xTypDokumentuMg = GetObjByKod("BTypDokumentuMg", sTyp)
		if !xTypDokumentuMg then  error "Brak takiego rekordu"
//		endif
	dst.Value("skrot") = xTypDokumentuMg.symbolFK

	// numer i data dokumentu korygowanego
	// musimy siegnac do dokumentu korygowanego pierwotnego
	// przyjete ze jest to pierwszy w kolekcji
	if xDokumentMg.DokumentZKorektami.Count() && xDokumentMg.DokumentZKorektami.item(1).Numer!= xDokumentMg.Numer then
		dst.Value("NazwaKor") = xDokumentMg.DokumentZKorektami.item(1).Numer
		dst.Value("DataKor") = xDokumentMg.DokumentZKorektami.item(1).Data
	endif

	// pozycje dokumentu
	for ii=1 to ii>xDokumentMg.Pozycje.Count()
		if ((!xDokumentMg.CzyKorekta) || (xDokumentMg.CzyKorekta && xDokumentMg.Pozycje.item(ii).idpozkoryg)) then
			DodajDoOpisu(xDokumentMg.Pozycje.item(ii).opis, "/")
		endif
	next ii

	// czy automatycznie doda transakcje
	int skipTrans = 0
	if defdok.moveTo( xTypDokumentuMg.symbolFK ) then
		skipTrans = ! ( AUTOTRANS_ITG & defdok.value("autoTrans") )
	endif

	//////////////////////////////////////////////////////
	// numer dokumentu w FK
	dst.Value("nazwa") = xDokumentMg.numer

    xDekretacjeMg.Clear()
	xDekretParams = xDekretacjeMg.Params()
	xDekretParams.id=xDokumentMg.id
	xDekretacjeMg.Dekret(xDekretParams)
	dst.Value("tresc")	= xDekretacjeMg.trescwFK  //opis fk
	ZapiszZAP2(xDekretacjeMg, 0, 0,0,xDokumentMg.termin, 0, "",0, skipTrans)
	dst.Validate()
	if (ers.Count) then IntegrMG = ShowError(xDokumentMg.nazwa+" "+xDokumentMg.numer)
	//if IntegrMG == 0 then dst.Insert()
	if IntegrMG == 0 then IntegrMG = !dst.Insert()
	ShowStatus(xDokumentMg.numer,idDK, IntegrMG)

EndSub

// zbiorcze

int Sub IntegrMG_zb_begin()
	dWartoscDok = 0
	terminplat = ""
	bPierwszyDokument = 1
	sOpisy=0
	nLastZap=0
EndSub

int Sub IntegrMG_zb_do(long idDK, int iOpcje)

	IntegrMG_zb_do = 0

	string sTyp
	int err
	float dWartosc
	int index, nSize
	Dispatch xDokMg
	Dispatch xTypDokumentuMg
	Dispatch xKsSchematMg
	int intAddDekret = 0
	int iRok

	nRes=!(xDokumentMg=GetObjById("BDokumentMg",idDK))
	if nRes then  Error "Brak takiego rekordu w bazie MG"

	iRok = dbd.firmainfo.GetRokByDate(xDokumentMg.dataWystawienia)
	if RokFK(1).Zap == 1 then

		if RokFK(1).IdRok != iRok then
			UstawRok(iRok)
		endif

	else
		UstawRok(iRok)
	endif

	dst = RokFK(1).Rok
	plkn = RokFK(1).PlanKont
	defdok = RokFK(1).DefDokument

	// sprawdzamy typ dokumentu
	Select Case xDokumentMg.charakter
		Case PW, PWK, RW, RWK, WZM, WZK, PZM, PZK, MMP, MKP, MMM, MKM, KWM, PWM, WDP, WPK, PZP, PPK
		Case Else
			IntegrMG_zb_do = 1 // pomijamy
			AddError("Nie mona wysa dokumentu " + xDokumentMg.numer + ".",idDK)
	EndSelect
	if ( IntegrMG_zb_do == 1 ) then Exit

	if CzyIntegrBrakSchematu(xDokumentMg.schematKsiegowania, xDokumentMg.numer, idDK) then
		IntegrMG_zb_do = 1 // pomijamy
		Exit
	endif

	xKsSchematMg = GetObjByKod("BKsSchematMg", xDokumentMg.schematKsiegowania)
	if xKsSchematMg then
		nRes = 0
	else
		nRes = 1
	endif

	if CzyIntegrBlednySchemat(nRes, xDokumentMg.numer, idDK) then
		IntegrMG_zb_do = 1 // pomijamy
		Exit
	endif

	if IntegrZatwWart(xDokumentMg, "", 1) then
		IntegrMG_zb_do = 1 // pomijamy
		Exit
	endif

	dWartosc = xDokumentMg.wartosc
	dWartoscDok += dWartosc

	if bPierwszyDokument then
		bPierwszyDokument = 0
		intAddDekret = 0
		dst.Clear()
		sTyp = xDokumentMg.typDk



		nRes = !(xDokMg=GetObjById("BDokMg",idDK))
		if nRes then  error "Dokument nie zaadowany"

		if xDokMg.czyZaimport then
			//dokument moze miec typ dokumentu wprowadzony tylko w centrali
			// sprawdzamy czy ma taki typ
			xTypDokumentuMg = GetObjByKod("BTypDokumentuMg", xDokumentMg.typDk)
			sTyp = ""
			if xTypDokumentuMg && (xDokumentMg.charakter == xTypDokumentuMg.charakter) then
				// typ dokumentu pasuje z odzdialu z centrala
				sTyp = xDokumentMg.typDk
			else
				// nie znaleizono typu o takim kodzie wiec
				// szukamy dla podstawowego typu dla charakteru dokumentu
				xTypDokumentuMg = GetObjByKod("BTypDokumentuMg", TypDOK(xDokumentMg.charakter))
				if !nRes && (xDokumentMg.charakter == xTypDokumentuMg.charakter) then
					sTyp = xDokumentMg.typDk
				else
					error "Brak takiego rekordu w bazie"
				endif
			endif
		endif
		if !(xDokMg.czyZaimport) || ((xDokMg.czyZaimport) && sTyp != "") then
			xTypDokumentuMg = GetObjByKod("BTypDokumentuMg", sTyp)
			if !xTypDokumentuMg then  error "Brak takiego rekordu w bazie"
		endif

		dst.Value("skrot") = xTypDokumentuMg.symbolFK
		dbd.CurrentDate = sDataWpr
		dst.Value("DataDok") = xDokumentMg.dataWystawienia
//		dst.Value("DataOkr") = xDokumentMg.dataWystawienia
		dst.Value("DataOper") = xDokumentMg.dataOperacji
		dst.Value("Datawpl") = Data()
		dst.Value("Datawpr") = sDataWpr
		if terminplat > xDokumentMg.termin then	terminplat = xDokumentMg.termin
		//////////////////////////////////////////////////////
		// numer dokumentu w FK
		dst.Value("nazwa") = xDokumentMg.numer
		xDekretacjeMg.Clear()
	else
		intAddDekret = 1
	endif

	xDekretParams = xDekretacjeMg.Params()
	xDekretParams.id=xDokumentMg.id
	xDekretParams.Dodaj = intAddDekret //(iOpcje & DEKRETY_ZBIORCZE)
	xDekretacjeMg.Dekret(xDekretParams)
//	if !(iOpcje & DEKRETY_ZBIORCZE) then
//	if !iDokumentZbiorczy then
//		ZapiszZAP(xDekretacjeMg, 0, 0,0,xDokumentMg.termin)
//	endif

EndSub


int Sub IntegrMG_zb_end(int iOpcje)

	int index
	int nCount = 1
	int nPozycja = 0

	// dokoczenie sekcji "Dokument"

	if iOpcje & DEKRETY_ZBIORCZE then xDekretacjeMg.Optymalizuj()

	if iDokumentZbiorczy then
		ZapiszZAP(xDekretacjeMg, 0, 0,0,terminplat, 0, "", 0)
	endif

	if ( dst ) then
		dst.Value("kwota") = Round( dWartoscDok )
		dst.Validate()
	endif

	if (ers.Count) then IntegrMG_zb_end = ShowError("Dokument zbiorczy")

	if ( dst ) then
		if IntegrMG_zb_end == 0 then IntegrMG_zb_end = !dst.Insert()

		dst.Clear()
	endif

	ShowStatus("Dokument zbiorczy",0, IntegrMG_zb_end)

EndSub

int Sub BeginProcessMG()
	if iDokumentZbiorczy then
		Shrink listaDokId, -1
		IntegrMG_zb_begin()
	endif
EndSub

int Sub DoProcessMG(long idDK)
	DoProcessMG = 0
	rozUidStrona = 0
	int iVal
	int iOpcje = 0
	Dispatch xDokMg = xFactory.NewObject("BDokMg")
	Dispatch xKartParamsDokMg = xFactory.NewObject("BKartParamsDokMg")

	nRes=!(xDokumentMg=GetObjById("BDokumentMg",idDK))
	if nRes then  Error "Brak takiego rekordu w bazie MG"


	nRes = !(xDokMg=GetObjById("BDokMg",idDK))
	if nRes then  error "Dokument nie zaadowany"

	if ( xDokMg.czyBufor ) then
		DoProcessMG = 1 // pomijamy
		AddError("Nie mona wysa niezatwierdzonego dokumentu " + xDokumentMg.numer+".",idDK)
		Exit // nie wysyamy dokumentw z bufora
	endif

	if ( xDokMg.czyAnulowany ) then
		DoProcessMG = 1 // pomijamy
		AddError("Nie mona wysa anulowanego dokumentu " + xDokumentMg.numer+".",idDK)
		Exit // nie wysyamy dokumentw anulowanych
	endif

	if ( iNieIntegrOznak && xDokMg.czyWyekspFK ) then
		DoProcessMG = 1 // pomijamy
		AddError("Nie mona powtrnie wysa dokumentu " + xDokumentMg.numer+".",idDK)
		Exit // nie wysyamy oznakowanych dokumentw
	endif

	if iDokumentZbiorczy then
		// czy dekrety zbiorcze
		if ( iDekretyZbiorcze ) then iOpcje |= DEKRETY_ZBIORCZE

		if IntegrMG_zb_do(idDK, iOpcje) then
			DoProcessMG = 1 // pomijamy
			Exit
		endif

		listaDokId(size(listaDokId)).lDokId = idDK
		Grow listaDokId, 1
	else
		DoProcessMG = IntegrMG(idDK)
		if	DoProcessMG then Exit	 // pomijamy
	endif

	if ( iOznaczaj && !iDokumentZbiorczy ) then
	//	nRes=!(xDokumentMg=GetObjById("BDokumentMg",idDK))
	//	if nRes then  Error "Brak takiego rekordu w bazie DK"


		nRes = !(xDokMg=GetObjById("BDokMg",idDK))
		if nRes then  error "Dokument nie zaadowany"

		xDokMg.SetEkspFK()
	endif
EndSub


int Sub EndProcessMG()

	int iOpcje = 0
	int index = 1
	int err, nRes
	Dispatch xDokMg

	if iDokumentZbiorczy && 1 < Size(listaDokId) then

		// czy dekrety zbiorcze
		if ( iDekretyZbiorcze ) then iOpcje |= DEKRETY_ZBIORCZE

		err = IntegrMG_zb_end(iOpcje)

		if ( !err && iOznaczaj ) then
			while index < Size(listaDokId)

				nRes = !(xDokMg=GetObjById("BDokMg",listaDokId(index).lDokId))
				if nRes then  error "Dokument nie zaadowany"

				xDokMg.SetEkspFK()

				index += 1
			wend
		endif

	endif

	Shrink listaDokId, -1
EndSub